searchData={"items":[{"type":"module","title":"Wongi.Engine","doc":"A forward-chaining inference engine for Elixir.\n\nA port of the Ruby library with the same name.","ref":"Wongi.Engine.html"},{"type":"function","title":"Wongi.Engine.assert/2","doc":"Returns an engine with the given fact added to the working memory.","ref":"Wongi.Engine.html#assert/2"},{"type":"function","title":"Wongi.Engine.assert/4","doc":"Returns an engine with the given fact added to the working memory.","ref":"Wongi.Engine.html#assert/4"},{"type":"function","title":"Wongi.Engine.compile/2","doc":"Returns an engine with the given rule installed.\n\nSee `Wongi.Engine.DSL` for details on the rule definition DSL.","ref":"Wongi.Engine.html#compile/2"},{"type":"function","title":"Wongi.Engine.compile_and_get_ref/2","doc":"Returns an engine with the given rule installed and the rule reference.\n\nThe rule reference can be used to retrieve production tokens using `tokens/2`.\n\nSee `Wongi.Engine.DSL` for details on the rule definition DSL.","ref":"Wongi.Engine.html#compile_and_get_ref/2"},{"type":"function","title":"Wongi.Engine.new/0","doc":"Creates a new engine instance.","ref":"Wongi.Engine.html#new/0"},{"type":"function","title":"Wongi.Engine.productions/1","doc":"Returns all production node references.","ref":"Wongi.Engine.html#productions/1"},{"type":"function","title":"Wongi.Engine.retract/2","doc":"Returns an engine with the given fact removed from the working memory.","ref":"Wongi.Engine.html#retract/2"},{"type":"function","title":"Wongi.Engine.retract/4","doc":"Returns an engine with the given fact removed from the working memory.","ref":"Wongi.Engine.html#retract/4"},{"type":"function","title":"Wongi.Engine.select/2","doc":"Returns a set of all facts matching the given template.","ref":"Wongi.Engine.html#select/2"},{"type":"function","title":"Wongi.Engine.select/4","doc":"Returns a set of all facts matching the given template.","ref":"Wongi.Engine.html#select/4"},{"type":"function","title":"Wongi.Engine.tokens/2","doc":"Returns a set of all tokens for the given production node reference.","ref":"Wongi.Engine.html#tokens/2"},{"type":"type","title":"Wongi.Engine.fact/0","doc":"","ref":"Wongi.Engine.html#t:fact/0"},{"type":"type","title":"Wongi.Engine.rule/0","doc":"","ref":"Wongi.Engine.html#t:rule/0"},{"type":"type","title":"Wongi.Engine.t/0","doc":"","ref":"Wongi.Engine.html#t:t/0"},{"type":"type","title":"Wongi.Engine.template/0","doc":"","ref":"Wongi.Engine.html#t:template/0"},{"type":"module","title":"Wongi.Engine.Aggregates","doc":"Aggregate helpers.","ref":"Wongi.Engine.Aggregates.html"},{"type":"function","title":"Wongi.Engine.Aggregates.max/1","doc":"","ref":"Wongi.Engine.Aggregates.html#max/1"},{"type":"function","title":"Wongi.Engine.Aggregates.min/1","doc":"","ref":"Wongi.Engine.Aggregates.html#min/1"},{"type":"function","title":"Wongi.Engine.Aggregates.product/1","doc":"","ref":"Wongi.Engine.Aggregates.html#product/1"},{"type":"function","title":"Wongi.Engine.Aggregates.sum/1","doc":"","ref":"Wongi.Engine.Aggregates.html#sum/1"},{"type":"module","title":"Wongi.Engine.DSL","doc":"Rule definition functions.","ref":"Wongi.Engine.DSL.html"},{"type":"function","title":"Wongi.Engine.DSL.aggregate/3","doc":"","ref":"Wongi.Engine.DSL.html#aggregate/3"},{"type":"function","title":"Wongi.Engine.DSL.any/0","doc":"","ref":"Wongi.Engine.DSL.html#any/0"},{"type":"function","title":"Wongi.Engine.DSL.any/1","doc":"","ref":"Wongi.Engine.DSL.html#any/1"},{"type":"function","title":"Wongi.Engine.DSL.assign/2","doc":"","ref":"Wongi.Engine.DSL.html#assign/2"},{"type":"function","title":"Wongi.Engine.DSL.diff/2","doc":"","ref":"Wongi.Engine.DSL.html#diff/2"},{"type":"function","title":"Wongi.Engine.DSL.equal/2","doc":"","ref":"Wongi.Engine.DSL.html#equal/2"},{"type":"function","title":"Wongi.Engine.DSL.fact/4","doc":"","ref":"Wongi.Engine.DSL.html#fact/4"},{"type":"function","title":"Wongi.Engine.DSL.filter/1","doc":"","ref":"Wongi.Engine.DSL.html#filter/1"},{"type":"function","title":"Wongi.Engine.DSL.gen/3","doc":"","ref":"Wongi.Engine.DSL.html#gen/3"},{"type":"function","title":"Wongi.Engine.DSL.greater/2","doc":"","ref":"Wongi.Engine.DSL.html#greater/2"},{"type":"function","title":"Wongi.Engine.DSL.gte/2","doc":"","ref":"Wongi.Engine.DSL.html#gte/2"},{"type":"function","title":"Wongi.Engine.DSL.has/4","doc":"","ref":"Wongi.Engine.DSL.html#has/4"},{"type":"function","title":"Wongi.Engine.DSL.in_list/2","doc":"","ref":"Wongi.Engine.DSL.html#in_list/2"},{"type":"function","title":"Wongi.Engine.DSL.less/2","doc":"","ref":"Wongi.Engine.DSL.html#less/2"},{"type":"function","title":"Wongi.Engine.DSL.lte/2","doc":"","ref":"Wongi.Engine.DSL.html#lte/2"},{"type":"function","title":"Wongi.Engine.DSL.missing/3","doc":"","ref":"Wongi.Engine.DSL.html#missing/3"},{"type":"function","title":"Wongi.Engine.DSL.ncc/1","doc":"","ref":"Wongi.Engine.DSL.html#ncc/1"},{"type":"function","title":"Wongi.Engine.DSL.neg/3","doc":"","ref":"Wongi.Engine.DSL.html#neg/3"},{"type":"function","title":"Wongi.Engine.DSL.none/1","doc":"","ref":"Wongi.Engine.DSL.html#none/1"},{"type":"function","title":"Wongi.Engine.DSL.not_in_list/2","doc":"","ref":"Wongi.Engine.DSL.html#not_in_list/2"},{"type":"function","title":"Wongi.Engine.DSL.rule/2","doc":"","ref":"Wongi.Engine.DSL.html#rule/2"},{"type":"function","title":"Wongi.Engine.DSL.var/1","doc":"","ref":"Wongi.Engine.DSL.html#var/1"},{"type":"module","title":"Wongi.Engine.DSL.Rule","doc":"A structure holding a rule definition.","ref":"Wongi.Engine.DSL.Rule.html"},{"type":"function","title":"Wongi.Engine.DSL.Rule.new/3","doc":"","ref":"Wongi.Engine.DSL.Rule.html#new/3"},{"type":"type","title":"Wongi.Engine.DSL.Rule.t/0","doc":"","ref":"Wongi.Engine.DSL.Rule.html#t:t/0"},{"type":"protocol","title":"Wongi.Engine.Filter","doc":"","ref":"Wongi.Engine.Filter.html"},{"type":"function","title":"Wongi.Engine.Filter.pass?/2","doc":"","ref":"Wongi.Engine.Filter.html#pass?/2"},{"type":"type","title":"Wongi.Engine.Filter.t/0","doc":"All the types that implement this protocol.","ref":"Wongi.Engine.Filter.html#t:t/0"},{"type":"module","title":"Wongi.Engine.Rete","doc":"The Rete network.\n\n`Wongi.Engine` is the public API. Avoid calling this module directly.","ref":"Wongi.Engine.Rete.html"},{"type":"function","title":"Wongi.Engine.Rete.add_beta/2","doc":"","ref":"Wongi.Engine.Rete.html#add_beta/2"},{"type":"function","title":"Wongi.Engine.Rete.add_ncc_token/3","doc":"","ref":"Wongi.Engine.Rete.html#add_ncc_token/3"},{"type":"function","title":"Wongi.Engine.Rete.add_neg_join_result/3","doc":"","ref":"Wongi.Engine.Rete.html#add_neg_join_result/3"},{"type":"function","title":"Wongi.Engine.Rete.add_token/2","doc":"","ref":"Wongi.Engine.Rete.html#add_token/2"},{"type":"function","title":"Wongi.Engine.Rete.assert/3","doc":"","ref":"Wongi.Engine.Rete.html#assert/3"},{"type":"function","title":"Wongi.Engine.Rete.assert/5","doc":"","ref":"Wongi.Engine.Rete.html#assert/5"},{"type":"function","title":"Wongi.Engine.Rete.beta_subscriptions/2","doc":"","ref":"Wongi.Engine.Rete.html#beta_subscriptions/2"},{"type":"function","title":"Wongi.Engine.Rete.compile/2","doc":"","ref":"Wongi.Engine.Rete.html#compile/2"},{"type":"function","title":"Wongi.Engine.Rete.compile_and_get_ref/2","doc":"","ref":"Wongi.Engine.Rete.html#compile_and_get_ref/2"},{"type":"function","title":"Wongi.Engine.Rete.get_beta/2","doc":"","ref":"Wongi.Engine.Rete.html#get_beta/2"},{"type":"function","title":"Wongi.Engine.Rete.has_ncc_tokens?/2","doc":"","ref":"Wongi.Engine.Rete.html#has_ncc_tokens?/2"},{"type":"function","title":"Wongi.Engine.Rete.ncc_owner/2","doc":"","ref":"Wongi.Engine.Rete.html#ncc_owner/2"},{"type":"function","title":"Wongi.Engine.Rete.neg_join_results/2","doc":"","ref":"Wongi.Engine.Rete.html#neg_join_results/2"},{"type":"function","title":"Wongi.Engine.Rete.new/0","doc":"","ref":"Wongi.Engine.Rete.html#new/0"},{"type":"function","title":"Wongi.Engine.Rete.productions/1","doc":"","ref":"Wongi.Engine.Rete.html#productions/1"},{"type":"function","title":"Wongi.Engine.Rete.remove_neg_join_result/3","doc":"","ref":"Wongi.Engine.Rete.html#remove_neg_join_result/3"},{"type":"function","title":"Wongi.Engine.Rete.remove_token/2","doc":"","ref":"Wongi.Engine.Rete.html#remove_token/2"},{"type":"function","title":"Wongi.Engine.Rete.retract/3","doc":"","ref":"Wongi.Engine.Rete.html#retract/3"},{"type":"function","title":"Wongi.Engine.Rete.retract/5","doc":"","ref":"Wongi.Engine.Rete.html#retract/5"},{"type":"function","title":"Wongi.Engine.Rete.select/2","doc":"","ref":"Wongi.Engine.Rete.html#select/2"},{"type":"function","title":"Wongi.Engine.Rete.select/4","doc":"","ref":"Wongi.Engine.Rete.html#select/4"},{"type":"function","title":"Wongi.Engine.Rete.subscribe_to_alpha/3","doc":"","ref":"Wongi.Engine.Rete.html#subscribe_to_alpha/3"},{"type":"function","title":"Wongi.Engine.Rete.subscribe_to_beta/3","doc":"","ref":"Wongi.Engine.Rete.html#subscribe_to_beta/3"},{"type":"function","title":"Wongi.Engine.Rete.tokens/2","doc":"","ref":"Wongi.Engine.Rete.html#tokens/2"},{"type":"function","title":"Wongi.Engine.Rete.trigger/2","doc":"","ref":"Wongi.Engine.Rete.html#trigger/2"},{"type":"type","title":"Wongi.Engine.Rete.t/0","doc":"","ref":"Wongi.Engine.Rete.html#t:t/0"},{"type":"module","title":"Wongi.Engine.Token","doc":"An intermediate data structure representing a partial match.","ref":"Wongi.Engine.Token.html"},{"type":"function","title":"Wongi.Engine.Token.ancestral_wme?/2","doc":"","ref":"Wongi.Engine.Token.html#ancestral_wme?/2"},{"type":"function","title":"Wongi.Engine.Token.child_of?/2","doc":"","ref":"Wongi.Engine.Token.html#child_of?/2"},{"type":"function","title":"Wongi.Engine.Token.child_of_any?/2","doc":"","ref":"Wongi.Engine.Token.html#child_of_any?/2"},{"type":"function","title":"Wongi.Engine.Token.descendant_of?/2","doc":"","ref":"Wongi.Engine.Token.html#descendant_of?/2"},{"type":"function","title":"Wongi.Engine.Token.fetch/2","doc":"","ref":"Wongi.Engine.Token.html#fetch/2"},{"type":"function","title":"Wongi.Engine.Token.fetch/3","doc":"","ref":"Wongi.Engine.Token.html#fetch/3"},{"type":"function","title":"Wongi.Engine.Token.has_wme?/2","doc":"","ref":"Wongi.Engine.Token.html#has_wme?/2"},{"type":"function","title":"Wongi.Engine.Token.new/4","doc":"","ref":"Wongi.Engine.Token.html#new/4"},{"type":"type","title":"Wongi.Engine.Token.t/0","doc":"","ref":"Wongi.Engine.Token.html#t:t/0"},{"type":"module","title":"Wongi.Engine.WME","doc":"A single fact in the form of `{subject, predicate, object}`.\n\n\"Working Memory Element\" in classic Rete terminology.","ref":"Wongi.Engine.WME.html"},{"type":"function","title":"Wongi.Engine.WME.fetch/2","doc":"","ref":"Wongi.Engine.WME.html#fetch/2"},{"type":"type","title":"Wongi.Engine.WME.t/0","doc":"","ref":"Wongi.Engine.WME.html#t:t/0"}],"content_type":"text/markdown"}